'Created by: X
'Copyright: Created by: X
'Web: http://www.createdbyx.com/
'Date: March 22, 2004
'=============================================


Imports ICSharpCode.SharpZipLib.Checksums
Imports ICSharpCode.SharpZipLib.Zip
Imports ICSharpCode.SharpZipLib.GZip

Public Class ZipFile
    Dim strmZipFile As System.IO.FileStream
    Dim strmZipStream As ZipOutputStream

    Public Event FileAdded()

    Public Sub Open(ByVal Filename As String)
        strmZipFile = System.IO.File.Open(Filename, IO.FileMode.OpenOrCreate)
        strmZipStream = New ZipOutputStream(strmZipFile)
    End Sub

    Friend Sub DoAddFile(ByVal Filename As String, ByVal InternalName As String)
        If Not System.IO.File.Exists(Filename) Then Exit Sub

        Dim strmStreamToZip As System.IO.FileStream
        strmStreamToZip = New System.IO.FileStream(Filename, System.IO.FileMode.Open, System.IO.FileAccess.Read)

        Dim myZipEntry As ZipEntry
        myZipEntry = New ZipEntry(InternalName)
        strmZipStream.PutNextEntry(myZipEntry)
        strmZipStream.SetLevel(9)

        Dim abyBuffer(1000) As Byte
        Dim nSize As System.Int32
        nSize = strmStreamToZip.Read(abyBuffer, 0, abyBuffer.Length)
        strmZipStream.Write(abyBuffer, 0, nSize)

        Try
            While (nSize < strmStreamToZip.Length)
                Dim nSizeRead As Integer
                nSizeRead = strmStreamToZip.Read(abyBuffer, 0, abyBuffer.Length)
                strmZipStream.Write(abyBuffer, 0, nSizeRead)
                nSize = nSize + nSizeRead
            End While

        Catch Ex As System.Exception
            Throw Ex

        End Try

        strmStreamToZip.Close()

        Try
            RaiseEvent FileAdded()
        Catch ex As Exception
            'ERR: handle error?
        End Try
    End Sub

    'Public Sub AddFiles(ByVal Filenames() As String, ByVal RootFolder As String)
    '    Dim idx As Integer

    '    For idx = 0 To Filenames.Length - 1
    '        DoAddFile(Filenames(idx), 9, 1000000, RootFolder)
    '    Next
    'End Sub

    'Public Sub AddFile(ByVal Filename As String, ByVal RootFolder As String)
    '    DoAddFile(Filename, 9, 1000000, RootFolder, )
    'End Sub

    Public Sub Close()
        strmZipStream.Finish()
        strmZipStream.Close()
    End Sub
End Class